import { RequestHandler } from 'express';
import { error } from './response';

export default (fn: RequestHandler, redir?: boolean): RequestHandler =>
  (req, res, next) =>
    (fn(req, res, next) as unknown as Promise<void>).catch((e) =>
      error(req, res, e, redir ? (req.query.redirect_uri as string) : undefined)
    );
